#ifndef _CMultiLanguageDialog_
#define _CMultiLanguageDialog_
#define noInit -1
typedef struct ST_LANG
{
	CString name;
	int id;
} StLang;

#include <afxtempl.h>
#include <XmlFile.h>
#include "Logfile.h"	// Hinzugefgt von der Klassenansicht

class CMultiLanguageDialog : public CDialog
{ 
  public :
	static CMap <_int64,_int64,CString,CString> m_Texte;
	static CArray<StLang,StLang> m_Languages;
	static CMap<int,int,int,int> m_diaMenu;
    
    int m_nID;


  public :
	  int m_LanguageDia;
	  int getLang();
	  CLogfile m_log;
	static  int readLanguages(CXmlFile &xHtml,CString &translTable,CMapStringToString &translChar,CArray<StLang,StLang> *languages=NULL);
	static  void readCharTable(CXmlFile &xHtml, CMapStringToString &translChar,int zeilePos);
	int findLangX(int id);
	int findLang(int id,BOOL cmpPrimary);
	static void html2txt(CString &txt,CMapStringToString &translChar);
	static CString getStringML(UINT id);
	static CString getTxtML(char type,UINT mid,UINT sid,UINT zeile=0);
	CMultiLanguageDialog( LPCTSTR lpszTemplateName, CWnd* pParentWnd = NULL );
	CMultiLanguageDialog( UINT nIDTemplate, CWnd* pParentWnd = NULL );
	CMultiLanguageDialog( );

	BOOL adjustLanguage( int language );
	BOOL adjustMenuLanguage( );

	  // Vom Klassenassistenten generierte berladungen virtueller Funktionen
	  //{{AFX_VIRTUAL(CAboutDlg)
	  protected:
	  virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-Untersttzung
	  //}}AFX_VIRTUAL
  
    // Implementation
  protected:

	  // Generated message map functions
	  //{{AFX_MSG(CTrayDialog)
	  virtual BOOL OnInitDialog( );
	  //}}AFX_MSG

  protected :
    DECLARE_MESSAGE_MAP()
private:
    static int m_LanguageAll;
	BOOL loadHTML();
};
#endif