// rc_translateDlg.cpp : Implementierungsdatei
//

#include "stdafx.h"
#include "rc_translate.h"
#include "rc_translateDlg.h"
#include <XmlFile.h>
#include "sys/stat.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg-Dialogfeld fr Anwendungsbefehl "Info"
typedef struct ST_EINTR
{
	char type;
	int zeile;
	int idNum;
	CString status;
	CString *texte;
} StEintr;
enum {UNBEKANNT,DIALOG1,DIALOG2,DIALOG3,MENU1,MENU2,STRTABLE,DLGINFO1,DLGINFO2,DLGINFO3};
enum {T_DIA,T_MEN,T_POP,T_STR,T_INID,T_LANG};
#define CSIDL_PROGRAM_FILES                   0x0026


class CAboutDlg : public CMultiLanguageDialog
{
public:
	CAboutDlg();

// Dialogfelddaten
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-Untersttzung
	//}}AFX_VIRTUAL

// Implementierung
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CMultiLanguageDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// Keine Nachrichten-Handler
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRc_translateDlg Dialogfeld

CRc_translateDlg::CRc_translateDlg(CWnd* pParent /*=NULL*/)
	: CMultiLanguageDialog(CRc_translateDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRc_translateDlg)
	m_rcFile = _T("");
	m_listFile = _T("");
	m_htmlFile = _T("");
	m_nLang = -1;
	//}}AFX_DATA_INIT
	// Beachten Sie, dass LoadIcon unter Win32 keinen nachfolgenden DestroyIcon-Aufruf bentigt
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CRc_translateDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRc_translateDlg)
	DDX_Text(pDX, IDC_RC, m_rcFile);
	DDX_Text(pDX, IDC_LIST, m_listFile);
	DDX_Text(pDX, IDC_HTML, m_htmlFile);
	DDX_CBIndex(pDX, IDC_LANG, m_nLang);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CRc_translateDlg, CDialog)
	//{{AFX_MSG_MAP(CRc_translateDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUT_RC, OnButRc)
	ON_BN_CLICKED(IDC_BUT_LIST, OnButList)
	ON_BN_CLICKED(IDC_BUT_HTML, OnButHtml)
	ON_BN_CLICKED(IDC_ADD_H, OnAddH)
	ON_BN_CLICKED(IDC_DEL_H, OnDelH)
	ON_CBN_EDITCHANGE(IDC_LANG, OnEditchangeLang)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRc_translateDlg Nachrichten-Handler

BOOL CRc_translateDlg::OnInitDialog()
{
	struct _stat buf;
	CMultiLanguageDialog::OnInitDialog();
	CListBox* pFB= (CListBox*)GetDlgItem(IDC_HFILES);

	// Hinzufgen des Menbefehls "Info..." zum Systemmen.

	// IDM_ABOUTBOX muss sich im Bereich der Systembefehle befinden.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{	
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Symbol fr dieses Dialogfeld festlegen. Wird automatisch erledigt
	//  wenn das Hauptfenster der Anwendung kein Dialogfeld ist
	SetIcon(m_hIcon, TRUE);			// Groes Symbol verwenden
	SetIcon(m_hIcon, FALSE);		// Kleines Symbol verwenden
	
	CString par=::GetCommandLine();
	int len0;
	if(par[0]=='\"')
	{
		len0=par.Find("\"",1);
		len0++;
	}
	else
		len0=par.Find(" ",1);
	if(par.GetLength()>len0)
	{
		par=par.Mid(len0+1);
		par.TrimLeft(" \t");
		if(par[0]=='\"')
		{
			len0=par.Find("\"",1);
			par=par.Mid(1,len0-1);
		}
		else
		{
			len0=par.Find(" ",1);
			if(len0>-1)
				par=par.Mid(0,len0);
		}
		if(!par.Right(3).CompareNoCase(".rc"))
		{
			if(_stat(par,&buf)==0)	// prfen ob das File besteht
			{
				char fName[_MAX_FNAME],fPath[_MAX_DIR],fDrv[_MAX_DRIVE],fExt[_MAX_EXT];
				_splitpath(par,fDrv,fPath,fName,fExt);
				m_htmlFile.Format("%s%s%s_lang.html",fDrv,fPath,fName);	//mu noch nicht existieren
				CString pfad;
				pfad.Format("%s%sresource.h",fDrv,fPath);
				if(_stat(pfad,&buf)==0)	// prfen ob das File besteht
					pFB->AddString(pfad);
				m_rcFile=par;
			}
		}
	}

	char pfade[_MAX_PATH]="";
	if(SHGetSpecialFolderPath(NULL,pfade,CSIDL_PROGRAM_FILES,TRUE))
	{
		CString hFile;
		hFile.Format("%s\\Microsoft Visual Studio\\VC98\\Include\\winuser.h",pfade);
		if(_stat(hFile,&buf)==0)	// prfen ob das File besteht
			pFB->AddString(hFile);
		hFile.Format("%s\\Microsoft Visual Studio\\VC98\\MFC\\Include\\afxres.h",pfade);
		if(_stat(hFile,&buf)==0)	// prfen ob das File besteht
			pFB->AddString(hFile);

	}
	if(SHGetSpecialFolderPath(NULL,pfade,CSIDL_PERSONAL,TRUE))
		m_listFile.Format("%s\\DYJ\\translAll.html",pfade);
	m_nLang=getLang();

	UpdateData(FALSE);
	
	return TRUE;  // Geben Sie TRUE zurck, auer ein Steuerelement soll den Fokus erhalten
}
void CRc_translateDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// Wollen Sie Ihrem Dialogfeld eine Schaltflche "Minimieren" hinzufgen, bentigen Sie 
//  den nachstehenden Code, um das Symbol zu zeichnen. Fr MFC-Anwendungen, die das 
//  Dokument/Ansicht-Modell verwenden, wird dies automatisch fr Sie erledigt.

void CRc_translateDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // Gertekontext fr Zeichnen

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Symbol in Client-Rechteck zentrieren
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Symbol zeichnen
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// Die Systemaufrufe fragen den Cursorform ab, die angezeigt werden soll, whrend der Benutzer
//  das zum Symbol verkleinerte Fenster mit der Maus zieht.
HCURSOR CRc_translateDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CRc_translateDlg::OnButRc() 
{
	static char szFilter[] = "Resource Files (*.rc)|*.rc||";
	UpdateData(TRUE);
	doFileselect(TRUE,m_rcFile,OFN_FILEMUSTEXIST,szFilter);
}

void CRc_translateDlg::OnButList() 
{
	static char szFilter[] = "HTML Files (*.html)|*.html||";
	UpdateData(TRUE);
	doFileselect(TRUE,m_listFile,OFN_FILEMUSTEXIST,szFilter);
}
	
void CRc_translateDlg::OnButHtml() 
{
	static char szFilter[] = "HTML Files (*.html)|*.html||";
	UpdateData(TRUE);
	doFileselect(FALSE,m_htmlFile,OFN_PATHMUSTEXIST,szFilter);
}

BOOL CRc_translateDlg::doFileselect(BOOL open,CString &fPath, int flag,char *filter)
{
	CString path=m_rcFile.Left(fPath.ReverseFind('\\'));
	CString file=fPath.Mid(fPath.ReverseFind('\\')+1);
	CFileDialog dlg(open,NULL,file,flag,filter);
	dlg.m_ofn.lpstrInitialDir=_T("G:\\\\tmp\\");
	if(dlg.DoModal()!=IDOK)
		return FALSE;
	fPath=dlg.GetPathName();
	UpdateData(FALSE);
	return TRUE;
}

void CRc_translateDlg::OnAddH() 
{
	CString newFile="";
	static char szFilter[] = "C++ Include Dateien (*.h)|*.h||";
	UpdateData(TRUE);
	if(doFileselect(TRUE,newFile,OFN_FILEMUSTEXIST,szFilter))
	{
		CListBox* pFB= (CListBox*)GetDlgItem(IDC_HFILES);
		pFB->AddString(newFile);
		UpdateData(FALSE);
	}
}

void CRc_translateDlg::OnOK() 
{
	CListBox* pFB= (CListBox*)GetDlgItem(IDC_HFILES);
	UpdateData(TRUE);
	for(int i=0;i<pFB->GetCount();i++)
	{
		CString pfad;
		pFB->GetText(i,pfad);
		readH(pfad);
	}


	readHTML(m_htmlFile);
	readAllHTML(m_listFile);
	readRC(m_rcFile);
	writeHTML(m_htmlFile);


	
	CDialog::OnOK();
}

BOOL CRc_translateDlg::readH(CString &pfad)
{
	BOOL ret=FALSE;
	CStdioFile inputF;
	if(inputF.Open(	pfad,CFile::modeRead))
	{
		CString zeile,text;
		ret=TRUE;
		inputF.ReadString(zeile);
		while( inputF.ReadString(zeile))
		{
			if(zeile.Find("#define")==0)
			{
				char *dummy;
				int val;
				zeile.Delete(0,7);
				zeile.TrimLeft(" \t");
				CString id=zeile.SpanExcluding(" \t");
				val=strtol(zeile.Mid(id.GetLength()),&dummy,0);
				Defines1.SetAt(id,val);
			}
		}
		inputF.Close();
	}
	return ret;

}

BOOL CRc_translateDlg::readHTML(CString &pfad)
{
	bool ret=false;
	CXmlFile xHtml;
	if(!xHtml.read2Buf(pfad))
	{
		CMultiLanguageDialog::m_Languages.RemoveAll();
		ST_LANG sprache;
		sprache.name="Original";
		sprache.id=LANG_NEUTRAL;
		CMultiLanguageDialog::m_Languages.Add(sprache);
		return ret;
	}
	int zeilePos=0,zeilePosS;
	CString translTable=xHtml.readVal("TABLE",&zeilePos);
//Men-IDs berspringen
	zeilePosS=zeilePos;
	CString dummy=xHtml.readVal("TABLE",&zeilePos);
	int zeilePosM=0;
	dummy=xHtml.readVal(dummy,"TR",&zeilePosM);//Titelzeile testen
	if(dummy.Find("Dialog-Id")==-1)
		zeilePos=zeilePosS;	//keine Menu Table vorhanden
//Zeichenkodierung ermitteln
	CMapStringToString translChar;
	CMultiLanguageDialog::readCharTable(xHtml,translChar,zeilePos);
//Sprachen auslesen
	zeilePos=CMultiLanguageDialog::readLanguages(xHtml,translTable,translChar);
	if(zeilePos)
	{
//Texte auslesen
		int anzSpr=CMultiLanguageDialog::m_Languages.GetSize();
		CString zeile;
		while(!(zeile=xHtml.readVal(translTable,"TR",&zeilePos)).IsEmpty())
		{
			int spaltePos=0;
			StEintr *eintr=new StEintr;
			eintr->texte =new CString[anzSpr];
			for(int i=1;i<anzSpr;i++)
				eintr->texte[i]="";

			CString id=xHtml.readVal(zeile,"TD",&spaltePos,NULL,TRIM|ELIM_TAGS);	//ID-Name 
			CString type=xHtml.readVal(zeile,"TD",&spaltePos,NULL,TRIM|ELIM_TAGS);
			if(!type.IsEmpty())
				eintr->type=type[0];
			eintr->zeile=xHtml.readVal_intDef(zeile,"TD",0,&spaltePos);	// 	Zeile
			eintr->idNum=xHtml.readVal_intDef(zeile,"TD",0,&spaltePos);	// 	IDs numerisch
			eintr->status=xHtml.readVal(zeile,"TD",&spaltePos,NULL,TRIM|ELIM_TAGS);	//Status
			if(eintr->status.IsEmpty())
				eintr->status="DEL";
			int spNr=0;
			BOOL hatLuecke=FALSE;
			while(zeile.Find("<TD",spaltePos)>-1)
			{
				eintr->texte[spNr]=xHtml.readVal(zeile,"TD",&spaltePos,NULL,TRIM|ELIM_TAGS);
				CMultiLanguageDialog::html2txt(eintr->texte[spNr++],translChar);
				if(eintr->texte[spNr])
					hatLuecke=TRUE;
			}
			Texte.SetAt(id,eintr);
			if(hatLuecke)
			{
				CString oldID,txt;
				txt="T"+eintr->texte[0];
				if(Txt2Id.Lookup(txt,oldID))
				{
					Txt2Id.SetAt(txt,id);
					id.Insert(0,"I");
					Txt2Id.SetAt(id,oldID);
				}
				else
					Txt2Id.SetAt(txt,id);
			}
		}
	}


	return ret;

}

BOOL CRc_translateDlg::readRC(CString &pfad)
{
	BOOL ret=FALSE;
	CStdioFile inputF;
	int status=UNBEKANNT;
	int anzSpr=CMultiLanguageDialog::m_Languages.GetSize();
	if(inputF.Open(	pfad,CFile::modeRead))
	{
		CString zeile,mid,sid,text;
		int menuNr=0,restBytes=0;
		ret=TRUE;
		while( inputF.ReadString(zeile))
		{
			if(zeile.Find("//////////")==0)
				status=UNBEKANNT;
			else
			{
				zeile.TrimLeft(" \t");
				if(status!=DLGINFO3)
				{
					while(!zeile.Right(1).Compare(" ") ||!zeile.Right(1).Compare(","))
					{
						CString zeile2;
						inputF.ReadString(zeile2);
						zeile2.TrimLeft(" \t");
						zeile+=zeile2;
					}
				}
			}

			switch(status)
			{
			case UNBEKANNT:
				{
					if(!zeile.Compare("// Dialog"))
						status=DIALOG1;
					else if(!zeile.Compare("// Menu"))
						status=MENU1;
					else if(!zeile.Compare("// String Table"))
						status=STRTABLE;
					else if(!zeile.Compare("// Dialog Info"))
						status=DLGINFO1;
				}
				break;
			case DIALOG1:
				{
					int idx=zeile.Find(" DIALOG");
					if(idx>-1)
					{
						mid=zeile.Left(idx);
						status=DIALOG2;
					}
				}
				break;
			case DIALOG2:
				{
					if(zeile.Find("CAPTION")==0)
					{
						text=zeile.Mid(9,zeile.GetLength()-10);
						add(mid,"",text,T_DIA);
						status=DIALOG3;
					}
				}
				break;
			case DIALOG3:
				{
					CString fstWrd=zeile.SpanExcluding(" \t");
					if(!fstWrd.Compare("END"))
					{
						status=DIALOG1;
						break;
					}
					CString keys=" CONTROL LTEXT RTEXT DEFPUSHBUTTON PUSHBUTTON GROUPBOX ";
					fstWrd.Insert(0," ");
					fstWrd+=" ";
					int keyIdx=keys.Find(fstWrd);
					if(keyIdx>-1)
					{
						int idx=zeile.Find("\"");
						if(idx>-1)
						{
							int idx2=idx-1;
							while(idx2>-1 && zeile[idx2+1]=='\"')
								idx2=zeile.Find("\"",idx2+2);
							if(idx2>-1)
							{
								int idx3=zeile.Find(",",idx2+2);
								if(idx3>-1)
								{
									text=zeile.Mid(idx+1,idx2-idx-1);
									sid=zeile.Mid(idx2+2,idx3-idx2-2);
									if(sid.Compare("IDC_STATIC")&&sid.Compare("-1"))
									{
										if(keyIdx || zeile.Find("\"Button\"",idx3)>-1)
											add(mid,sid,text,T_DIA);
									}
								}
							}
						}
					}
					else if(zeile.Find("MENU")==0)
					{
						int val=0;
						sid=zeile.Mid(5);
						int diaId=-1,menuId=-1;
						if(!mid.IsEmpty())
							Defines1.Lookup(mid,diaId);
						if(!sid.IsEmpty())
							Defines1.Lookup(sid,menuId);
						if(diaId>-1&&menuId>-1)
							m_diaMenu.SetAt(diaId,menuId);
					}
				}

				break;
			case DLGINFO1:
				{
					int idx=zeile.Find(" DLGINIT");
					if(idx>-1)
					{
						mid=zeile.Left(idx);
						status=DLGINFO2;
					}
				}
				break;
			case DLGINFO2:
				if(zeile.Compare("END"))
				{
					int idx=zeile.Find("0x1234");
					if(idx==-1)
						idx=zeile.Find("0x403");
					if(idx>-1)
					{
						sid=zeile.Left(idx);
						sid.TrimRight(" ,");
						idx=zeile.Find(',',idx);
						if(idx>-1)
						{
							char *dummy;
							status=DLGINFO3;
							restBytes=strtol(zeile.Mid(idx+1),&dummy,0);
							text="";
						}
					}
				}
				else
					status=DLGINFO1;

				break;
			case DLGINFO3:
				{
					int idx=0;
					while((idx=zeile.Find("\"\\000\""))>-1)
					{
						zeile.Delete(idx,6);
						zeile.Insert(idx,"0x0000");
					}
					idx=0;
					do
					{
						char *dummy;
						int wort=strtol(zeile.Mid(idx),&dummy,0);
						char str[3]="ab";
						str[0]=(char)wort;
						str[1]=(char)(wort>>8);
						text+=str;
						idx=zeile.Find("0x",idx+1);
						restBytes-=2;
					}while(idx>-1 && restBytes>0);
					if(restBytes<1)
					{
						if(text.Compare("_LANGUAGE_"))
							add(mid,sid,text,T_INID);
						else
						{
							for(int sprNr=0;sprNr<anzSpr;sprNr++)
								add(mid,sid,CMultiLanguageDialog::m_Languages[sprNr].name,T_LANG);
						}
						status=DLGINFO2;
					}
				}
				break;
			case MENU1:
				{
					int idx=zeile.Find(" MENU");
					if(idx>-1)
					{
						mid=zeile.Left(idx);
						status=MENU2;
						menuNr=0;
					}
				}
				break;
			case MENU2:
				{
					int idx=zeile.Find("POPUP");
					if(idx>-1)
					{
						text=zeile.Mid(idx+5);
						text.TrimLeft(" \t");
						text.Delete(0);
						text.TrimRight(" \t");
						text=text.Left(text.GetLength()-1);
						sid.Format("%d",menuNr++);
						add(mid,sid,text,T_POP);
					}
					else
					{
						idx=zeile.Find("MENUITEM");
						if(idx>-1)
						{
							text=zeile.Mid(idx+8);
							text.TrimLeft(" \t");
							if(text[0]=='\"')	//sonst SEPERATOR o..
							{
								idx=-1;
								do
								{
									idx=text.Find("\"",idx+2);
								}while(idx>-1 && text[idx+1]=='\"');
								text.Delete(0);
								if(idx>-1)
								{
									idx--;	//wegen Delete(0)
									sid=text.Mid(idx);
									sid.TrimLeft(" \t\",");
									text=text.Left(idx);
									add(mid,sid,text,T_MEN);
								}
							}
						}
					}
				}
				break;
			case STRTABLE:
				{
					int idx=zeile.Find('\"');
					if(idx>-1)
					{
						sid=zeile.Left(idx);
						text=zeile.Mid(idx+1);
						sid.TrimRight(" \t\"");
						idx=text.ReverseFind('\"');
						if(idx)
							text=text.Left(idx);
						add("",sid,text,T_STR);
					}
				}
				break;
			}
		}
	}
	return ret;

}
int cmpCString( const void *arg1, const void *arg2 )
{
	CString *str1=(CString *)arg1,*str2=(CString *)arg2;
	return str1->Compare(*str2);
}

void CRc_translateDlg::writeHTML(CString &pfad)
{
	FILE *gXrc=fopen(pfad,"w");
	if(gXrc)
	{
//Kopf
		fprintf(gXrc,"<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0 Transitional//EN\">\n");
		fprintf(gXrc,"<HTML>\n");
		fprintf(gXrc,"<HEAD>\n");
		fprintf(gXrc,"<META HTTP-EQUIV=\"CONTENT-TYPE\" CONTENT=\"text/html; charset=windows-1252\">\n");
		fprintf(gXrc,"<META HTTP-EQUIV=\"CONTENT-TYPE\" CONTENT=\"text/html; charset=windows-1252\">\n");
		fprintf(gXrc,"<TITLE></TITLE>\n");
		fprintf(gXrc,"<STYLE TYPE=\"text/css\">\n");
		fprintf(gXrc,"</STYLE>\n");
		fprintf(gXrc,"</HEAD>\n");
		fprintf(gXrc,"<BODY LANG=\"de-DE\" DIR=\"LTR\">\n");

//Texte
		fprintf(gXrc,"<P STYLE=\"margin-bottom: 0cm\"><FONT SIZE=7 STYLE=\"font-size: 20pt\"><U>Resource Translate</U></FONT></P><BR>\n");
		fprintf(gXrc,"<TABLE WIDTH=100%% BORDER=1 BORDERCOLOR=\"#000000\" CELLPADDING=4 CELLSPACING=0>\n");
	
		CString zeile;
		int anz=Texte.GetCount();
		CString *ids=new CString[anz];
		POSITION  pos = Texte.GetStartPosition();
		for( int i=0;i<anz;i++ )
		{
			StEintr *eintr;
			Texte.GetNextAssoc( pos, ids[i], (void*&)eintr );
		}
		qsort(ids,anz,sizeof(CString),cmpCString);

		fprintf(gXrc,"\t<TR VALIGN=TOP>\n");
		fprintf(gXrc,"\t\t<TD>\n\t\t\t<P><B>ID-Name</B></P>\n\t\t</TD>\n");
		fprintf(gXrc,"\t\t<TD>\n\t\t\t<P><B>Type</B></P>\n\t\t</TD>\n");
		fprintf(gXrc,"\t\t<TD>\n\t\t\t<P><B>Line</B></P>\n\t\t</TD>\n");
		fprintf(gXrc,"\t\t<TD>\n\t\t\t<P><B>ID-Num</B></P>\n\t\t</TD>\n");
		fprintf(gXrc,"\t\t<TD>\n\t\t\t<P><B>Status</B></P>\n\t\t</TD>\n");
		int anzSpr=CMultiLanguageDialog::m_Languages.GetSize();
		for(int s=0;s<anzSpr;s++)
			fprintf(gXrc,"\t\t<TD>\n\t\t\t<P><B>%s</B></P>\n\t\t</TD>\n",CMultiLanguageDialog::m_Languages[s].name);
		fprintf(gXrc,"\t</TR>\n");

		fprintf(gXrc,"\t<TR VALIGN=TOP>\n");
		fprintf(gXrc,"\t\t<TD>\n\t\t\t<P>Lang-ID</B></P>\n\t\t</TD>\n");
		fprintf(gXrc,"\t\t<TD>\n\t\t\t<P>L</P>\n\t\t</TD>\n");
		fprintf(gXrc,"\t\t<TD>\n\t\t\t<P>0</P>\n\t\t</TD>\n");
		fprintf(gXrc,"\t\t<TD>\n\t\t\t<P>0</P>\n\t\t</TD>\n");
		fprintf(gXrc,"\t\t<TD>\n\t\t\t<P> </P>\n\t\t</TD>\n");
		for(s=0;s<anzSpr;s++)
			fprintf(gXrc,"\t\t<TD>\n\t\t\t<P>%d</P>\n\t\t</TD>\n",CMultiLanguageDialog::m_Languages[s].id);
		fprintf(gXrc,"\t</TR>\n");

		for(i=0;i<anz;i++ )
		{
			StEintr *eintr;
			Texte.Lookup(ids[i], (void*&)eintr );
			fprintf(gXrc,"\t<TR VALIGN=TOP>\n");
			fprintf(gXrc,"\t\t<TD>\n\t\t\t<P>%s</P>\n\t\t</TD>\n",ids[i]);
			fprintf(gXrc,"\t\t<TD>\n\t\t\t<P>%c</P>\n\t\t</TD>\n",eintr->type);
			fprintf(gXrc,"\t\t<TD>\n\t\t\t<P>%d</P>\n\t\t</TD>\n",eintr->zeile);
			fprintf(gXrc,"\t\t<TD>\n\t\t\t<P>0x%x</P>\n\t\t</TD>\n",eintr->idNum);
			fprintf(gXrc,"\t\t<TD>\n\t\t\t<P>%s</P>\n\t\t</TD>\n",eintr->status);
			for(int s=0;s<anzSpr;s++)
				fprintf(gXrc,"\t\t<TD>\n\t\t\t<P>%s</P>\n\t\t</TD>\n",eintr->texte[s]);
			fprintf(gXrc,"\t</TR>\n");
		}
		delete [] ids;
		fprintf(gXrc,"</TABLE>\n<BR>\n");
//Menu
		fprintf(gXrc,"<P STYLE=\"margin-bottom: 0cm\"><FONT SIZE=7 STYLE=\"font-size: 20pt\"><U>Menu Table (do not change)</U></FONT></P><BR>\n");
		fprintf(gXrc,"<TABLE WIDTH=100%% BORDER=1 BORDERCOLOR=\"#000000\" CELLPADDING=4 CELLSPACING=0>\n");
		fprintf(gXrc,"\t<TR VALIGN=TOP>\n");
		fprintf(gXrc,"\t\t<TD>\n\t\t\t<P><B>Dialog-Id</B></P>\n\t\t</TD>\n");
		fprintf(gXrc,"\t\t<TD>\n\t\t\t<P><B>Menu-ID</B></P>\n\t\t</TD>\n");
		fprintf(gXrc,"\t</TR>\n");
		pos=m_diaMenu.GetStartPosition ();
		while(pos)
		{
			int diaId,menuId;
			m_diaMenu.GetNextAssoc( pos, diaId,menuId );
			fprintf(gXrc,"\t<TR VALIGN=TOP>\n");
			fprintf(gXrc,"\t\t<TD>\n\t\t\t<P>%d</P>\n\t\t</TD>\n",diaId);
			fprintf(gXrc,"\t\t<TD>\n\t\t\t<P>%d</P>\n\t\t</TD>\n",menuId);
			fprintf(gXrc,"\t</TR>\n");
		}
		fprintf(gXrc,"</TABLE>\n</BODY>\n</HTML>");

//Char		
		
		fprintf(gXrc,"<P STYLE=\"margin-bottom: 0cm\"><FONT SIZE=7 STYLE=\"font-size: 20pt\"><U>Character Table (do not change)</U></FONT></P><BR>\n");
		fprintf(gXrc,"<TABLE WIDTH=100%% BORDER=1 BORDERCOLOR=\"#000000\" CELLPADDING=4 CELLSPACING=0>\n");
		fprintf(gXrc,"\t<TR VALIGN=TOP>\n");
		fprintf(gXrc,"\t\t<TD>\n\t\t\t<P><B>Nr</B></P>\n\t\t</TD>\n");
		fprintf(gXrc,"\t\t<TD>\n\t\t\t<P><B>char</B></P>\n\t\t</TD>\n");
		fprintf(gXrc,"\t</TR>\n");
	
		for(i=32;i<256;i++ )
		{
			fprintf(gXrc,"\t<TR VALIGN=TOP>\n");
			fprintf(gXrc,"\t\t<TD>\n\t\t\t<P>%d</P>\n\t\t</TD>\n",i);
			switch(i)
			{
			case '<':
				fprintf(gXrc,"\t\t<TD>\n\t\t\t<P>&lt;</P>\n\t\t</TD>\n");
				break;
			case '>':
				fprintf(gXrc,"\t\t<TD>\n\t\t\t<P>&gt;</P>\n\t\t</TD>\n");
				break;
			case '&':
				fprintf(gXrc,"\t\t<TD>\n\t\t\t<P>&amp;</P>\n\t\t</TD>\n");
				break;
			default:
				fprintf(gXrc,"\t\t<TD>\n\t\t\t<P>%c</P>\n\t\t</TD>\n",(char)i);
				break;
			}
			fprintf(gXrc,"\t</TR>\n");
		}
		fprintf(gXrc,"</TABLE>\n</BODY>\n</HTML>");
		fclose(gXrc);
	}

}

void CRc_translateDlg::add(CString mid, CString sid, CString txt, int type)
{
	StEintr *eintr;
	CString id;
	int zeile=0;
	char typeC='I';
	id.Format("%s(%s)",mid,sid);
	int val=0;
	CString tst=txt.SpanIncluding("0123456789+-*/ .<>");
	int a=tst.GetLength();
	int b=txt.GetLength();
	if(a==b)
		return;
	if(!txt.Compare("Static"))
		return;
	switch(type)
	{
	case T_DIA:
		typeC='D';
		break;
	case T_POP:
		zeile=atoi(sid);
		sid="";
		id.Format("%s:%d",mid,zeile);
	case T_MEN:
		typeC='M';
		break;
	case T_STR:
		id.Format("STRING_TABLE(%s)",sid);
		typeC='S';
		break;
	case T_LANG:
		typeC='L';
	case T_INID:
		{
			if(DiaInitZeilen.Lookup(id,val))
				zeile=val;
			DiaInitZeilen.SetAt(id,++zeile);
			id.Format("%s(%s):%d",mid,sid,zeile);
		}
		break;

	}
	BOOL isNew=FALSE;
	txt.Replace("\"\"","\"");
	if(Texte.Lookup(id,(void *&)eintr))	// bereits vorhanden
	{
		if(eintr->texte[0].Compare(txt) && type!=T_LANG)
		{
			eintr->status="CHG";
			eintr->texte[0]=txt;
			isNew=TRUE;
		}
		else if(!eintr->status.Compare("DEL"))
			eintr->status="";
	}
	else
	{
		int anzSpr=CMultiLanguageDialog::m_Languages.GetSize();
		isNew=TRUE;
		eintr=new StEintr;
		eintr->texte =new CString[anzSpr];
		eintr->status="NEW";
		eintr->texte[0]=txt;
		for(int i=1;i<anzSpr;i++)
			eintr->texte[i]="";
	}
	if(isNew)
	{
		eintr->texte[0].Replace("&","&amp;");
		eintr->texte[0].Replace("<","&lt;");
		eintr->texte[0].Replace(">","&gt;");
	}
	if(!mid.IsEmpty())
	{
		Defines1.Lookup(mid,val);
		eintr->idNum=val<<16;
	}
	else
		eintr->idNum=0;
	eintr->type=typeC;
	eintr->zeile=zeile;
	if(!sid.IsEmpty())
	{
		Defines1.Lookup(sid,val);
		eintr->idNum+=val;
	}
	Texte.SetAt(id,eintr);

}




BOOL CRc_translateDlg::readAllHTML(CString &pfad)
{
	bool ret=false,addThis=TRUE;;
	CXmlFile xHtml;
	if(!xHtml.read2Buf(pfad))	//Liste neu anlegen
	{
		FILE *gXrc=fopen(pfad,"w");
		if(gXrc)
		{
//Kopf
			fprintf(gXrc,"<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0 Transitional//EN\">\n");
			fprintf(gXrc,"<HTML>\n");
			fprintf(gXrc,"<HEAD>\n");
			fprintf(gXrc,"<META HTTP-EQUIV=\"CONTENT-TYPE\" CONTENT=\"text/html; charset=windows-1252\">\n");
			fprintf(gXrc,"<TITLE></TITLE>\n");
			fprintf(gXrc,"<STYLE TYPE=\"text/css\">\n");
			fprintf(gXrc,"</STYLE>\n");
			fprintf(gXrc,"</HEAD>\n");
			fprintf(gXrc,"<BODY LANG=\"de-DE\" DIR=\"LTR\">\n");

//Liste
			char fName[_MAX_FNAME],fPath[_MAX_DIR],fDrv[_MAX_DRIVE],fExt[_MAX_EXT];
			_splitpath(m_htmlFile,fDrv,fPath,fName,fExt);
			fprintf(gXrc,"<P STYLE=\"margin-bottom: 0cm\"><A HREF=\"/%s\">%s%s</A></P><BR>\n",m_htmlFile,fName,fExt);
			fprintf(gXrc,"</BODY>\n</HTML>");
			fclose(gXrc);
			addThis=FALSE;
		}
	}
	else
	{
		int zeilePos=0;
		CString path;
		while(!(path=xHtml.readAttr("A",&zeilePos)).IsEmpty())
		{
			int idx=path.Find('/');
			if(idx>-1)
				path.Delete(0,idx+1);
			path.Delete(path.GetLength()-1);
			if(!path.CompareNoCase(m_htmlFile))
				addThis=FALSE;
			readOtherHTML(path);
		}
		if(addThis)
		{
			int idx=xHtml.m_sBuf.Find("</BODY>");
			if(idx>-1)
			{
				char fName[_MAX_FNAME],fPath[_MAX_DIR],fDrv[_MAX_DRIVE],fExt[_MAX_EXT];
				_splitpath(m_htmlFile,fDrv,fPath,fName,fExt);
				CString newLine;
				newLine.Format("<P STYLE=\"margin-bottom: 0cm\"><A HREF=\"/%s\">%s%s</A></P><BR>\n",m_htmlFile,fName,fExt);
				xHtml.m_sBuf.Insert(idx,newLine);
				FILE *gXrc=fopen(pfad,"w");
				if(gXrc)
				{
					fwrite(xHtml.m_sBuf,1,xHtml.m_sBuf.GetLength(),gXrc);
					fclose(gXrc);
				}
			}
		}
	}
	return ret;

}

BOOL CRc_translateDlg::readOtherHTML(CString &pfad)
{
	bool ret=false;
	CXmlFile xHtml;
	if(!xHtml.read2Buf(pfad))
		return ret;
	int zeilePos=0;
	CString translTable=xHtml.readVal("TABLE",&zeilePos);
//Zeichenkodierung ermitteln
	CMapStringToString translChar;
	CMultiLanguageDialog::readCharTable(xHtml,translChar,zeilePos);
//Sprachen auslesen
	int anzSpr1=CMultiLanguageDialog::m_Languages.GetSize(),anzSpr2=0;
	CArray<StLang,StLang> tmpLanguages;
	zeilePos=CMultiLanguageDialog::readLanguages(xHtml,translTable,translChar,&tmpLanguages);
	if(zeilePos)
	{
//Texte auslesen
		int *idCnv=new int[anzSpr1];
		anzSpr2=tmpLanguages.GetSize();
		for(int i=0;i<anzSpr1;i++)
		{
			idCnv[i]=-1;
			for(int j=0;j<anzSpr2;j++)
			{
				if(tmpLanguages[j].id==CMultiLanguageDialog::m_Languages[i].id)
				{
					idCnv[i]=j;
					break;
				}
			}
		}
		if(idCnv[0]>-1)
		{
			CString zeile;
			CString *texte=new CString[anzSpr2];
			while(!(zeile=xHtml.readVal(translTable,"TR",&zeilePos)).IsEmpty())
			{
				int spaltePos=0;
				for(int i=0;i<5;i++)
					xHtml.readVal(zeile,"TD",&spaltePos);
				int spNr=0;
				BOOL hatLuecke=FALSE;
				while(zeile.Find("<TD",spaltePos)>-1)
				{
					texte[spNr]=xHtml.readVal(zeile,"TD",&spaltePos,NULL,TRIM|ELIM_TAGS);
					CMultiLanguageDialog::html2txt(texte[spNr++],translChar);
				}
				CString suchTxt;
				suchTxt.Format("T%s",texte[idCnv[0]]);
				do
				{
					CString id;
					if(Txt2Id.Lookup(suchTxt,id))
					{
						BOOL save=FALSE;
						StEintr *eintr;
						Texte.Lookup(id,(void*&)eintr);
						for(int i=0;i<anzSpr1;i++)
						{
							if(idCnv[i]>-1 && eintr->texte[i].IsEmpty())
							{
								if(!texte[idCnv[i]].IsEmpty())
								{
									eintr->texte[i]=texte[idCnv[i]];
									save=TRUE;
								}
							}
						}
						if(save)
							Texte.SetAt(id,eintr);
						suchTxt.Format("I%s",id);
					}
					else
						break;
				}while(!suchTxt.IsEmpty());
			}
		}
	}


	return ret;

}

void CRc_translateDlg::OnDelH() 
{
	CListBox* pFB= (CListBox*)GetDlgItem(IDC_HFILES);
	pFB->DeleteString(pFB->GetCurSel());
	
}

void CRc_translateDlg::OnEditchangeLang() 
{
	UpdateData(TRUE);
	adjustLanguage(m_nLang  );
	
}
