#include "StdAfx.h"
//#include "resource.h"
//#include "ILanguage.h"
#include "CMultiLanguageDialog.h" 

int CMultiLanguageDialog::m_LanguageAll=noInit;
CMap <_int64,_int64,CString,CString> CMultiLanguageDialog::m_Texte;
CMap<int,int,int,int> CMultiLanguageDialog::m_diaMenu;
CArray<StLang,StLang> CMultiLanguageDialog::m_Languages;
//CArray<StLang,StLang> CMultiLanguageDialog::m_TmpLanguages;

CMultiLanguageDialog::CMultiLanguageDialog( LPCTSTR lpszTemplateName, CWnd* pParentWnd )
: CDialog( lpszTemplateName, pParentWnd )
{
  // Noch nicht bentigter Eingang
  _asm int 3;
}

CMultiLanguageDialog::CMultiLanguageDialog( UINT nIDTemplate, CWnd* pParentWnd )
: CDialog( nIDTemplate, pParentWnd )
{
  m_nID = nIDTemplate;
  m_LanguageDia=noInit;
}
CMultiLanguageDialog::CMultiLanguageDialog( )
: CDialog()
{
  // Noch nicht bentigter Eingang
  _asm int 3;
}

void CMultiLanguageDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CMultiLanguageDialog, CDialog)
END_MESSAGE_MAP()

BOOL CMultiLanguageDialog::OnInitDialog()
{
	CDialog::OnInitDialog();
	int language=m_LanguageAll;
	if(language==noInit)
	{
		loadHTML();
		language=findLangX(GetUserDefaultLangID());
	}
	m_LanguageDia =noInit;
	adjustLanguage( language );

	return( TRUE );
}

BOOL CMultiLanguageDialog::adjustLanguage( int language )
{
	m_LanguageAll = language;
	if(m_LanguageDia == language)
		return TRUE;
	m_LanguageDia = language;
	m_log.writeFLS("adjustLanguage");
	CString str;

	GetWindowText( str );
	m_log.writeFLS(str);
	TRACE( "dialog : %s\n", str );
	CString txt=getTxtML('D',m_nID,0);
	if(!txt.IsEmpty())
		SetWindowText(txt);
	m_log.writeFLS(txt);
	CWnd *p = GetWindow( GW_CHILD );
	while ( NULL != p )
	{
		p->GetWindowText( str );
		m_log.writeFLS(str);
		int n = p->GetDlgCtrlID( );
		TRACE( "%x : %s\n", n, str );

		txt=getTxtML('D',m_nID,n);
		if(!txt.IsEmpty())
			p->SetWindowText(txt);
		m_log.writeFLS(txt);

		char cname[128];
		GetClassName(p->m_hWnd,cname,128);
		if(!strcmp(cname,"ComboBoxEx32"))
		{
			CComboBoxEx *combo=(CComboBoxEx*)p;
			char type='I';
			int anz=combo->GetCount();
			for(int i=0;i<anz;i++)
			{
				txt=getTxtML(type,m_nID,n,i+1);
				m_log.writeFLS(txt);
				if(txt.IsEmpty() && type=='I')
				{
					txt=getTxtML('L',m_nID,n,i+1);
					if(!txt.IsEmpty())
						type='L';
				}
				if(!txt.IsEmpty())
				{
					COMBOBOXEXITEM item;
					item.mask = CBEIF_TEXT;
					item.iItem = i;
					item.pszText = txt.GetBuffer(0);
					item.cchTextMax=txt.GetLength()+1;
					BOOL ok=combo->SetItem(&item);
					if(type=='L')
					{
						anz=i+2;
						if(!ok)
						{
							ok=combo->InsertItem(&item);
							TRACE("ok=%d\n",(int)ok);
						}
					}
					txt.ReleaseBuffer();
				}
			}
		}
		else if(!strcmp(cname,"ComboBox"))
		{
			CComboBox *combo=(CComboBox*)p;
			int anz=combo->GetCount();
			for(int i=0;i<anz;i++)
			{
				txt=getTxtML('I',m_nID,n,i+1);
				m_log.writeFLS(txt);
				if(!txt.IsEmpty())
				{
					int ret1=combo->DeleteString(i);
					int ret2=combo->InsertString(i,txt);
					TRACE("%d %d",ret1,ret2);
				}
			}
		}
		else if(!strcmp(cname,"SysTabControl32"))
		{
			CTabCtrl *tabC=(CTabCtrl*)p;
			int anz=tabC->GetItemCount();
			for(int i=0;i<anz;i++)
			{
				TCITEM tcItem;
				tcItem.mask=TCIF_PARAM;
				if(tabC->GetItem(i,&tcItem))
				{
					CString text=getStringML(tcItem.lParam);
					if(!text.IsEmpty())
					{
						tcItem.mask=TCIF_TEXT;
						tcItem.pszText = (char*)LPCSTR(text);
						tabC->SetItem(i, &tcItem);
					}
				}
			}
		}

		p = p->GetWindow( GW_HWNDNEXT );
	}

	adjustMenuLanguage();

	return( TRUE );
}

BOOL CMultiLanguageDialog::adjustMenuLanguage( )
{


	int mid;
	if(!m_diaMenu.Lookup(m_nID,mid))
		return FALSE;

	unsigned int dwMainMenuItem = 0;
	//  DWORD dwID = ID_BASEMENU;
	//  int apMain->GetDlgCtrlID();
	while ( dwMainMenuItem < GetMenu()->GetMenuItemCount())
	{
		CString txt=getTxtML('M',mid,0,dwMainMenuItem );
		if(!txt.IsEmpty())
			GetMenu()->ModifyMenu( dwMainMenuItem, MF_BYPOSITION, dwMainMenuItem,txt);
		if ( NULL != GetMenu()->GetSubMenu( dwMainMenuItem ) )
		{
			unsigned int dwSubMenuItem = 0;    

			while ( dwSubMenuItem < GetMenu()->GetSubMenu( dwMainMenuItem )->GetMenuItemCount())
			{
				DWORD dwID = GetMenu()->GetSubMenu( dwMainMenuItem )->GetMenuItemID( dwSubMenuItem );
				if(dwID)
				{
					txt=getTxtML('M',mid, dwID);
					if(!txt.IsEmpty())
						GetMenu()->GetSubMenu( dwMainMenuItem )->ModifyMenu( dwSubMenuItem, MF_BYPOSITION, dwID, txt );  
				}
				dwSubMenuItem++;
			}
		}
		dwMainMenuItem++;
	}

	DrawMenuBar();
	return( TRUE );
}

CString CMultiLanguageDialog::getTxtML(char type,UINT mid,UINT sid,UINT zeile)
{
	CString ret;
	_int64 id=(_int64(type)<<56) +(_int64(zeile)<<48)+(_int64(mid)<<32)+(sid<<16)+m_LanguageAll;
	if(!m_Texte.Lookup(id,ret))
		ret="";
	return ret;

}

CString CMultiLanguageDialog::getStringML(UINT id)
{
	CString ret=getTxtML('S',0,id);
	if(ret.IsEmpty())
		ret.Format(id);
	return ret;
}

BOOL CMultiLanguageDialog::loadHTML()
{
	bool ret=false;
	CString par=::GetCommandLine(),pfad;
	int len0;
	if(par[0]=='\"')
	{
		len0=par.Find("\"",1);
		pfad=par.Mid(1,len0-1);
	}
	else
	{
		len0=par.Find(" ",1);
		pfad=par.Mid(0,len0);
	}
	int idx=pfad.ReverseFind('.');
	if(idx>-1)
	{
		CString zeile;
		pfad=pfad.Left(idx)+"_lang.html";
		CXmlFile xHtml;
		CString source;
		if(!xHtml.read2Buf(pfad))
			return ret;
		int zeilePos=0,zeilePosS;
		CString translTable=xHtml.readVal("TABLE",&zeilePos);
//Men-IDs auslesen
		zeilePosS=zeilePos;
		CString menuTable=xHtml.readVal("TABLE",&zeilePos);
		int zeilePosM=0;
		zeile=xHtml.readVal(menuTable,"TR",&zeilePosM);//Titelzeile testen
		if(zeile.Find("Dialog-Id")>-1)
		{
			while(!(zeile=xHtml.readVal(menuTable,"TR",&zeilePosM)).IsEmpty())
			{
				int spaltePos=0;
				int diaId=xHtml.readVal_intDef(zeile,"TD",0,&spaltePos);
				int menuId=xHtml.readVal_intDef(zeile,"TD",0,&spaltePos);
				m_diaMenu.SetAt(diaId,menuId);
			}
		}
		else
			zeilePos=zeilePosS;	//keine Menu Table vorhanden

//Zeichenkodierung ermitteln
		CMapStringToString translChar;
		readCharTable(xHtml,translChar,zeilePos);
//Sprachen auslesen
		zeilePos=readLanguages(xHtml,translTable,translChar);
		if(zeilePos)
		{
//Texte auslesen
			while(!(zeile=xHtml.readVal(translTable,"TR",&zeilePos)).IsEmpty())
			{
				int spaltePos=0;
				_int64 typZ=0;
				xHtml.readVal(zeile,"TD",&spaltePos);	//ID-Name 
				CString type=xHtml.readVal(zeile,"TD",&spaltePos,NULL,TRIM|ELIM_TAGS);
				if(!type.IsEmpty())
					typZ=type[0];		//tt
				typZ=(typZ<<8)+xHtml.readVal_intDef(zeile,"TD",0,&spaltePos);	// ttzz
				_int64 id=xHtml.readVal_intDef(zeile,"TD",0,&spaltePos);	// iiiiiiii	IDs numerisch
				id=(id<<16)+(typZ<<48);	// ttzziiiiiiii0000
				xHtml.readVal(zeile,"TD",&spaltePos);	//Status
 				int spNr=0;

				while(zeile.Find("<TD",spaltePos)>-1)
				{
					CString text=xHtml.readVal(zeile,"TD",&spaltePos,NULL,TRIM|ELIM_TAGS);
					if(!spNr && (int)strspn(text," ,\"")==text.GetLength())	//dann nur Originalsprache -> keine bersetzung
						break;
					if(!text.IsEmpty())
					{
						html2txt(text,translChar);
						m_Texte.SetAt(id+(spNr++),text);
					}
				}
			}
		}

	}
	return ret;

}

void CMultiLanguageDialog::html2txt(CString &txt, CMapStringToString &translChar)
{
	CString neu="";
	int len=txt.GetLength();
	for(int i=0;i<len;i++)
	{
		int idxA=i;
		CString tChar;
		if(txt[i]=='\n' || txt[i]=='\r')
		{
			i+=strspn(txt.Mid(i),"\r\n\t ")-1;
			neu+=" ";
		}
		else
		{
			if(txt[i]=='&')
			{
				int idxE=txt.Find(';',i);
				if(idxE>-1)
					i=idxE;
			}
			if(translChar.Lookup(txt.Mid(idxA,i-idxA+1),tChar))
				neu+=tChar;
			else
				neu+=txt.Mid(idxA,i-idxA+1);
		}
	}
	txt=neu;		
}

int CMultiLanguageDialog::findLang(int id, BOOL cmpPrimary)
{

	if(cmpPrimary)
	{
		for(int i=0;i<m_Languages.GetSize();i++)
		{
			if(PRIMARYLANGID(m_Languages[i].id)==id)
				return i;
		}
	}
	else
	{
		for(int i=0;i<m_Languages.GetSize();i++)
		{
			if(m_Languages[i].id==id)
				return i;
		}
	}
	return noInit;
}

int CMultiLanguageDialog::findLangX(int id)
{
	int ret=noInit;

	ret=findLang(id,FALSE);						//	suche genaue Sprache
	if(ret!=noInit)
		return(ret);
	ret=findLang(PRIMARYLANGID(id),FALSE);	//	suche Primary Sprache
	if(ret!=noInit)
		return(ret);
	ret=findLang(PRIMARYLANGID(id),TRUE);	//	suche irgendeine Sprache mit gleicher Primary
	if(ret!=noInit)
		return(ret);
	ret=findLang(9,FALSE);					//	suche Englisch Primary
	if(ret!=noInit)
		return(ret);
	ret=findLang(9,TRUE);					//	suche irgendein Englisch 
	if(ret!=noInit)
		return(ret);
	else
		return(0);									//	na dann

}

void CMultiLanguageDialog::readCharTable(CXmlFile &xHtml, CMapStringToString &translChar,int zeilePos)
{
	CString zeile,zelle,charTable=xHtml.readVal("TABLE",&zeilePos);
	zeilePos=0;
	
	zeile=xHtml.readVal(charTable,"TR",&zeilePos);
	if(!(xHtml.readVal(zeile,"TD",NULL,NULL,TRIM|ELIM_TAGS)).Compare("Nr"))
	{
		while(!(zeile=xHtml.readVal(charTable,"TR",&zeilePos)).IsEmpty())
		{
			int spaltePos=0;
			CString zeichen=(unsigned char)CXmlFile::readVal_intDef(zeile,"TD",0,&spaltePos);
			zelle=xHtml.readVal(zeile,"TD",&spaltePos,NULL,TRIM|ELIM_TAGS);
			if(!zelle.IsEmpty() && zelle.Compare(zeichen))
				translChar.SetAt(zelle,zeichen);
		}
	}

}
int CMultiLanguageDialog::readLanguages(CXmlFile &xHtml,CString &translTable,CMapStringToString &translChar,CArray<StLang,StLang> *languages)
{
	int zeilePos=0;
	CString zeile=xHtml.readVal(translTable,"TR",&zeilePos);
	if(!(xHtml.readVal(zeile,"TD",NULL,NULL,TRIM|ELIM_TAGS)).Compare("ID-Name"))
	{
		int spaltePos=0,spaltePos2=0;
		CString zeile2=xHtml.readVal(translTable,"TR",&zeilePos);
		for(int i=0;i<5;i++)
		{
			xHtml.readVal(zeile,"TD",&spaltePos);
			xHtml.readVal(zeile2,"TD",&spaltePos2);
		}
		if(languages==NULL)
			languages=&m_Languages;
		languages->RemoveAll();
		int dummyId=128;

		while(zeile.Find("<TD",spaltePos)>-1)
		{
			ST_LANG sprache;
			sprache.name=xHtml.readVal(zeile,"TD",&spaltePos,NULL,TRIM|ELIM_TAGS);
			sprache.id=xHtml.readVal_intDef(zeile2,"TD",dummyId++,&spaltePos2);
			if(!sprache.name.IsEmpty())
			{
				html2txt(sprache.name,translChar);
				languages->Add(sprache);
			}
		}
	}
	else
		zeilePos=0;
	return zeilePos;
}

int CMultiLanguageDialog::getLang()
{
	return m_LanguageAll;
}
