// Logfile.cpp: Implementierung der Klasse CLogfile.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Logfile.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////
CString CLogfile::m_path="";
CLogfile::CLogfile()
{
	if(!m_path.IsEmpty())
		return;
	CString par=::GetCommandLine();

	int len0;
	CString exePath="";
	if(par[0]=='\"')
	{
		len0=par.Find("\"",1);
		exePath=par.Mid(1,len0-1);
		len0++;
	}
	else
	{
		len0=par.Find(" ",1);
		exePath=par.Mid(0,len0);
	}
	int idx=exePath.ReverseFind('.');
	if(idx==-1)
		idx=exePath.GetLength();
	m_path=exePath.Left(idx)+".log";
	CFile log(m_path,CFile::modeCreate|CFile::modeWrite);
	CString txt;
	txt.Format("Logfile for %s\r\n",exePath); 
	log.Write(txt,txt.GetLength());
	log.Close();

}

CLogfile::~CLogfile()
{

}

void CLogfile::write(CString file,int line,CString str)
{
	CFile log(m_path,CFile::modeReadWrite);
	log.SeekToEnd();
	CString txt;
	txt.Format("%s: %d %s\r\n",file,line,str);
	log.Write(txt,txt.GetLength());
	log.Close();

}
